/* killpg() for MiNT */

#include <stdlib.h>
#include <errno.h>
#include <osbind.h>
#include <signal.h>
#include <unistd.h>
#include <mintbind.h>

#include "lib.h"

/* vector of signal handlers (for TOS) */
extern __Sigfunc _sig_handler[];	/* in signal.c */

/* vector giving which signals are currently blocked from delivery (for TOS) */
extern long _sigmask;			/* in signal.c */

/* which signals are pending? */
extern long _sigpending;

static short _have_pkill;

int
__killpg(pgrp, sig)
	int pgrp, sig;
{
	long r;

	if (pgrp < 0) {
		errno = ERANGE;
		return -1;
	}
	r = Pkill(-pgrp, sig);
	/* (void)Syield(); */

	if (r == -EINVAL)
	{
		_have_pkill = 0;
		if (pgrp == 0 || pgrp == getpgrp())
			return kill(getpid(), sig);
	}		
	if (r < 0) {
		errno = (int) -r;
		return -1;
	}
	return 0;
}

#ifdef HAVE_WEAK_SYMBOLS
weak_alias (__killpg, killpg)
#endif
